--MAIN CODE--

--post 2.2.7 anti-deprecation
local BTn_USE = nil
if BT_SPIN
	BTn_USE = BT_SPIN
else
	BTn_USE = BT_USE
end
/*
--dumb camera workaround (krabs)
local consoleplayer_camera = nil
local function getcam(v, player, camera)
    consoleplayer_camera = camera
end
hud.add(getcam, "game")
*/

--dumb camera workaround
local consoleplayer_camera = nil
local function getcam(v, player, camera)
    consoleplayer_camera = camera
end
hud.add(getcam, "game")

--ability disable bitflags, intended for p.abilityflags
--to work independently of p.bannedvars
local SPYABIL_NOGLIDE = 1
local SPYABIL_NOHOVER = 2
local SPYABIL_NOHEADBASH = 4
local SPYABIL_NOROLLOUT = 8
local SPYABIL_NOCHARGE = 16
local SPYABIL_NOFIRE = 32

--local vars
local bubblesnd = {sfx_bubbl1, sfx_bubbl2, sfx_bubbl3, sfx_bubbl4, sfx_bubbl5}
local holdflame = false
local speedmul = cv_spyrospeedmul.value
--local cv_chasecam = CV_FindVar("chasecam")
local cv_friendlyfire = CV_FindVar("friendlyfire")
local camhooked = false

local function angfix(input)
	if input > ANGLE_MAX
		input = $ - ANGLE_MAX
	end
	if input < ANGLE_MAX
		input = $ + ANGLE_MAX
	end
	return input
end
/*
if consoleplayer_camera.chase == false
etc
*/

--PLAYER PRETHINK
addHook("PreThinkFrame", do
	for p in players.iterate
		if p.mo and p.mo.skin == "spyro"
			local function ScaledSpeedMul(input)
				return FixedMul(FixedMul(input, cv_spyrospeedmul.value), p.mo.scale)
			end
			
			if p.chargeangle == nil then p.chargeangle = 0 end
			
			--countering momentum mod's influence when not charging
			if not(p.cmd.buttons & BTn_USE)
			and not (p.charging or p.aircharging)
			and p.walkspeed --wait for walkspeed var to initialize unless you like runtimes
				p.normalspeed = FixedMul(cv_spyrospeedmul.value, p.walkspeed)
			end
			
			--end glide if interupted
			if p.mo.state == S_PLAY_FALL and p.gliding
			and abs(p.mo.momz) ~= FixedMul(p.glideratio, p.mo.scale)
				--print("break")
				P_InstaThrust(p.mo, p.mo.angle, p.speed/2)
				p.gliding = false
				p.glidecooldown = TICRATE/10
			end
			
			--print(p.cmd.angleturn/(FRACUNIT/100))
			--print(p.cmd.aiming/(FRACUNIT/100))
			
			--mouse polling for charge steering
			local CLAMPANG = ANG1*12
			--print(((p.cmd.angleturn << 16) - (p.mo.angle))/ANG1)
			p.mousedx = (p.cmd.angleturn << 16) - (p.mo.angle)
			p.clampedmousedx = p.mousedx
			p.mousedy = (p.cmd.aiming << 16) - (p.aiming)
			
			--keep within 360 plz
			if p.clampedmousedx > ANGLE_MAX
				p.clampedmousedx = $ - ANGLE_MAX
			end
			if p.clampedmousedx < ANGLE_MAX
				p.clampedmousedx = $ + ANGLE_MAX
			end
			
			p.clampedmousedx = $ /3
			
			if p.clampedmousedx > CLAMPANG
				p.clampedmousedx = CLAMPANG
			end
			if p.clampedmousedx < -CLAMPANG
				p.clampedmousedx = -CLAMPANG
			end
			
			--print(p.clampedmousedx / ANG1)
			
			--nerf turn angle when charging via analog mode shenanigans
			if cv_spyrochargeturn.value == 1
			and not valueInTable(p.mo.state, bannedStates)
				if (p.charging or p.aircharging)
					p.cmd.forwardmove = 50
					--print(p.cmd.angleturn/FRACUNIT)
					--print( FixedDiv(p.cmd.sidemove, FRACUNIT+(8*FRACUNIT/10)) )
					
					/*--fiddle with sidemove to decrease turn angle based on if player has supercharge
					if p.supercharging
						p.cmd.sidemove = FixedDiv(p.cmd.sidemove, FRACUNIT+(90*FRACUNIT/100)) --sidemove/1.95
						p.cmd.sidemove = FixedMul(p.cmd.sidemove, (11*FRACUNIT)/10)
					else
						p.cmd.sidemove = FixedDiv(p.cmd.sidemove, FRACUNIT+(8*FRACUNIT/10)) --sidemmove/1.8
						p.cmd.sidemove = FixedMul(p.cmd.sidemove, (11*FRACUNIT)/10)
					end
					print(p.cmd.sidemove)
					if p.cmd.sidemove > 33
						p.cmd.sidemove = 33
					elseif p.cmd.forwardmove < -33
						p.cmd.sidemove = -33
					end*/
					--p.pflags = $ | PF_FORCESTRAFE
					--clear modes
					if p.pflags & PF_ANALOGMODE
						p.mo.angle = $ +0 --this forces the camera to look ahead of spyro
						p.mo.angle = p.drawangle
						p.pflags = $ & !PF_ANALOGMODE --b/c w/o analog mode it makes spyro charge at where the cam is facing
						p.analogtoggle = true
					end
					
					if (p.pflags & PF_DIRECTIONCHAR)
						p.pflags = $ & !PF_DIRECTIONCHAR 
						p.dirchartoggle = true
					end
				else --return values to their original settings
					--p.pflags = $ & ~PF_FORCESTRAFE
					if not (p.pflags & PF_ANALOGMODE)
					and p.analogtoggle
						p.pflags = $ | PF_ANALOGMODE
						p.analogtoggle = false
					end
					--p.drawangle = p.mo.angle
					if not (p.pflags & PF_DIRECTIONCHAR)
					and p.dirchartoggle
						p.pflags = $ | PF_DIRECTIONCHAR
						p.dirchartoggle = false
					end
				end --the quirk with this is that legacy/strafe controls become standard controls after charging
			end
			
			--2d mode fixes
			if twodlevel or (p.mo.flags2 & MF2_TWOD)
				if p.drawangle > ANGLE_180
				and (p.charging or p.aircharging)
					p.cmd.forwardmove = 0
					p.cmd.sidemove = 1
				elseif (p.charging or p.aircharging)
					p.cmd.forwardmove = 0
					p.cmd.sidemove = -1
				end
			end
		end
	end
end)

--GLIDE CHECK
addHook("AbilitySpecial", function(p)
	if p.mo and p.mo.skin == "spyro"
		--don't glide underwater
		if (p.mo.eflags & MFE_UNDERWATER)
			p.gliding = false
			return false
		end
		
		--begin glide
		if not p.gliding
			p.gliding = true
			p.aircharging = false
			return true
		end
	end
end)

--SHIELD ABILITY OVERRIDE
addHook("ShieldSpecial", function (p)
	--don't do shield action w/ Elemental, Bubble, Force, and Armageddon shields
	--they negatively impact movement or are inoportune to use
	--these shields are action'd elsewhere
	if p.mo and p.mo.skin == "spyro"
		if p.powers[pw_shield] == SH_FLAMEAURA
			p.pflags = $ | PF_SPINNING
			p.mo.state = S_PLAY_ROLL
			p.shieldcooldown = TICRATE*3
			--p.charging = false
			--p.aircharging = false
			return nil
		end
		
		if p.powers[pw_shield] == SH_ELEMENTAL
		or p.powers[pw_shield] == SH_BUBBLEWRAP
		or (p.powers[pw_shield] & SH_FORCE)
		or p.powers[pw_shield] == SH_ARMAGEDDON
			return true
		else
			--cooldown upon use of shield abilities
			p.shieldcooldown = 3*TICRATE
			return false
		end
	end
end)

--PLAYER THINKER
addHook("PlayerThink", function(p)
	--idealy this should probably be outside of the hook but we need player_t
	local function ScaledSpeedMul(input)
		return FixedMul(FixedMul(input, cv_spyrospeedmul.value), p.mo.scale)
	end
	
	if p.mo and p.mo.skin == "spyro"
		--set up vars
		local cv_chasecam = CV_FindVar("chasecam")
		--local chasecam_on = cv_chasecam.value
		local chasecam_on = 0
		--local chasecam2_on = cv_chasecam2.value
		--local chasecam_on = consoleplayer_camera.chase
		
		--if netgame 
		if isdedicatedserver
			chasecam_on = 0
		else
			chasecam_on = CV_FindVar("chasecam")
		end
		
		if p.carrytimeout == nil then p.carrytimeout = 0 end
				
		p.glidespeed = 20*FRACUNIT
		--p.glideratio = 4*FRACUNIT --proper glide ratio is 20:4 or 5:1
		if p.glidecooldown == nil then p.glidecooldown = 0 end
		if p.shieldcooldown == nil then p.shieldcooldown = 0 end
		if p.bashready == nil then p.bashready = 7 end
		if p.hovering == nil then p.hovering = 0 end
		--p.glidectrl = 0
		--p.glideratio = 1*FRACUNIT
		
		if p.chargecooldown == nil then p.chargecooldown = 0 end
		p.walkspeed = 15*FRACUNIT
		p.chargespeed = 29*FRACUNIT
		p.airchargespeed = 22*FRACUNIT
		p.superchargespeed = 40*FRACUNIT
		p.superchargedashspeed = 50*FRACUNIT
		p.normaljumpfactor = (11*FRACUNIT)/10
		p.chargejumpfactor = (80*FRACUNIT)/100
		
		if p.sflamecooldown == nil then p.sflamecooldown = 0 end
		if p.shootcharge == nil then p.shootcharge = 0 end
		
		if p.abilityflags == nil then p.abilityflags = 0 end
		if p.chargeangle == nil then p.chargeangle = 0 end
		
		--check jump button tap
		if not (p.cmd.buttons & BT_JUMP)
			p.jumptapready = true
			p.jumptap = false
		elseif p.jumptapready then
			p.jumptap = true
			p.jumptapready = false
		else
			p.jumptap = false
		end
		
		--print(p.normalspeed)
		
		--test button, look at all this debug stuff!
		if p.cmd.buttons & BT_CUSTOM3
			--p.mo.colorized = true
			--p.pflags = $ | PF_STARTJUMP
			--P_ResetPlayer(p)
			--P_Thrust(p.mo, p.mo.angle, 1*FRACUNIT)
			--print(p.glidecooldown)
			--p.powers[pw_shield] = SH_FLAMEAURA
			--P_SpawnShieldOrb(p)
			--p.pflags = $ & !PF_ANALOGMODE
			--p.pflags = $ & !PF_DIRECTIONCHAR
			--p.pflags = $ | PF_FORCESTRAFE
			--p.mo.angle = $ + cv_testangle.value
			--p.cmd.angleturn = 32767
			--P_DamageMobj(p.mo, nil, nil, 1)
			--print(p.runspeed)
			--print(CV_FindVar("friendlyfire"))
			--print(p.mo.z/FRACUNIT - p.mo.floorz/FRACUNIT)
			--print((p.mo.ceilingz/FRACUNIT) - ((p.mo.z/FRACUNIT)+(p.mo.height/FRACUNIT)))
			--print(p.camera)
			--p.pflags = $ | PF_NOCLIP
		end
		
		--check custom 1 button tap
		if not (p.cmd.buttons & BT_CUSTOM1)
			p.custom1tapready = true
			p.custom1tap = false
		elseif p.custom1tapready then
			p.custom1tap = true
			p.custom1tapready = false
		else
			p.custom1tap = false
		end
		
		--check custom 2 button tap
		if not (p.cmd.buttons & BT_CUSTOM2)
			p.custom2tapready = true
			p.custom2tap = false
		elseif p.custom2tapready then
			p.custom2tap = true
			p.custom2tapready = false
		else
			p.custom2tap = false
		end 
		
		--bannedvars, variables that restrict spyro's abillities and/or player input
		if p.dirk_frozen --dirk the husky's freeze
		or p.mo.frostburnt --frostburn eggman boss freeze
		or p.frozen --mystic realm ce
		or p.guard --battlemod
		or p.iseggrobo --battlemod, eggrobo-tag
		or p.eggrobo_transforming
		or (p.isjettysyn and cv_spyro_jettysynfun.value == 0)--battlemod, jettysyn vengence
		or p.playerstate ~= PST_LIVE
		or p.powers[pw_nocontrol] ~= 0
		or p.realtime <= 0
		or (p.pflags & (PF_STASIS|PF_FULLSTASIS|PF_SPINNING))
		or (p.eggride and p.eggride.state) --riding eggmobile
			p.bannedvars = true
		else
			p.bannedvars = false
		end
	
		
		--force into a spin if springed while stopped
		if ((p.mo.eflags & MFE_SPRUNG) or GetSecSpecial(p.mo.subsector.sector.special, 3) == 5)
		and (p.mo.momx == 0 and p.mo.momy == 0)
		and P_IsObjectOnGround(p.mo)
		--and p.speed > FixedMul(p.chargespeed, cv_spyrospeedmul.value)
			p.pflags = $ | PF_SPINNING
			p.mo.state = S_PLAY_ROLL
			p.charging = false
			p.aircharging = false
		end
		
		--are we in flipped gravity?
		if p.mo.eflags & (MF2_OBJECTFLIP|MFE_VERTICALFLIP)
			p.gravflip = true
		else
			p.gravflip = false
		end
		
		--start carry timeout when carried
		--inb4 just use pw_ignorelatch
		if p.powers[pw_carry] then p.carrytimeout = TICRATE/4 end
		
		--disable coyote time in certain conditions
		--if p.powers[pw_shield] == SH_WHIRLWIND
		if (p.mo.momz > 2*FRACUNIT and not p.gravflip)
		or (p.mo.momz < -2*FRACUNIT and p.gravflip)
		or p.powers[pw_carry] ~= 0
		and p.coyote
			p.coyote = 0
		end
		
		--force jumped flag on z momentum and not underwater and not in carry timeout and not carried 
		--(necessary to glide out of being springed)
		--unless in the coyote time
		--if (p.mo.momz ~= 0 or (p.mo.eflags & MFE_SPRUNG)) 
		if p.mo.momz ~= 0
		and not (p.mo.eflags & MFE_UNDERWATER) 
		and p.carrytimeout <= 0 and p.mo.state ~= PA_PAIN 
		and (p.powers[pw_carry] == 0)
		and not p.coyote
			p.pflags = $ | PF_JUMPED	
		end
		
		--clear jumped flag when on ground or being carried
		if (P_IsObjectOnGround(p.mo) or p.powers[pw_carry])
		--if (p.mo.eflags & MFE_JUSTHITFLOOR)
		and (p.pflags & PF_JUMPED)
		and not (p.pflags & (PF_SPINNING))
		and not (p.mo.eflags & (MFE_SPRUNG|MFE_JUSTHITFLOOR))
			p.pflags = $ & ~PF_JUMPED
		end
		
		--change color when invincible
		/*
		if p.powers[pw_invulnerability] > 0
			p.mo.color = SKINCOLOR_CRIMSON
			--p.mo.colorized = true --a red blob w/ no contrast when colorized
			--p.mo.color = SKINCOLOR_SPUERRED1 --runtimes, something about arg #3 being nil
		--revert color when not super or have some other colorchanging attribute
		elseif p.powers[pw_super] == 0
		and not p.mo.pw_goldrush --esp (extra shield powers)
		and not p.elemtimer --oldc, snowflake ridge powerup gate
		and not p.bannedvars
			p.mo.color = p.skincolor
			--p.mo.colorized = false
		end
		*/
		
		--decrement carry timeout
		if p.carrytimeout then p.carrytimeout = $ -1 end
		
		
		--force no jump damage flag when in pain or other conditions
		if p.mo.state == S_PLAY_PAIN
		or p.mo.state == S_PLAY_FALL
		or p.mo.state == S_PLAY_JUMP
		or p.mo.state == S_PLAY_SPRING
		or p.mo.state == S_PLAY_GLIDE
		or p.mo.state == S_PLAY_FLY
		or p.mo.state == S_PLAY_SWIM
		or (p.mo.state == S_PLAY_WALK and not P_IsObjectOnGround(p.mo))
		and not (p.pflags & PF_NOJUMPDAMAGE)
			p.pflags = $ | PF_NOJUMPDAMAGE
		end
		
		--clear pain anim when not on grnd, no iframes, and descending
		if (p.mo.state == S_PLAY_PAIN) 
		and p.powers[pw_flashing] == 0
		and ((p.mo.momz < -8*p.mo.scale and not(p.mo.eflags & (MF2_OBJECTFLIP | MFE_VERTICALFLIP))) 
		or (p.mo.momz > 8*p.mo.scale and (p.mo.eflags & (MF2_OBJECTFLIP | MFE_VERTICALFLIP))))
			if (p.pflags & PF_SPINNING)
			--	p.pflags = $ & ~PF_SPINNING --clear spin flag too if present
			end
			p.mo.state = S_PLAY_FALL
		end
		
		
		--clear spin flag if descneding (hopefully nothing will break)
		if (p.pflags & PF_SPINNING)
		--and (p.cmd.buttons & BT_JUMP)
		and ((p.mo.momz < -4*p.mo.scale and not(p.mo.eflags & (MF2_OBJECTFLIP | MFE_VERTICALFLIP))) 
		or (p.mo.momz > 4*p.mo.scale and (p.mo.eflags & (MF2_OBJECTFLIP | MFE_VERTICALFLIP)))) 
		and (abs(p.mo.momx) > 1*(p.mo.scale/2) or abs(p.mo.momy) > 1*(p.mo.scale*2))
			p.pflags = $ & ~PF_SPINNING
		end
		
		--replace walk anim with falling anim when spyro is, ya know, falling
		if not P_IsObjectOnGround(p.mo)
		and ((p.mo.momz < -1*FRACUNIT and not p.gravflip) or (p.mo.momz > 1*FRACUNIT and not p.gravflip)) --the 1FU/T difference gives a nice follow through
		and p.mo.state == S_PLAY_WALK
		and not (p.charging or p.aircharging)
		and not p.coyote
			p.mo.state = S_PLAY_FALL
		end
		
		--play pain anim when deep in quicksand
		if P_InQuicksand(p.mo)
		and p.mo.floorrover
		and ((p.mo.z + (p.mo.height)) - p.mo.floorrover.topheight) < 24*p.mo.scale
			if p.mo.state ~= S_PLAY_DEAD --pain anim doesn't animate :/
				p.mo.state = S_PLAY_DEAD --using dead instead since it's the same as pain
			end
		end
		
		--replace dead anim w/ pain anim when on ground
		if P_IsObjectOnGround(p.mo)
		and not P_InQuicksand(p.mo)
		and p.playerstate == PST_LIVE
		and p.mo.state == S_PLAY_DEAD
			p.mo.state = S_PLAY_PAIN
		end
		
		--sparx allows spyro to not drown/spacedrown
		if p.mo.sparx and p.mo.sparx.valid and p.mo.sparx.health
			if p.powers[pw_underwater] > 0
				p.powers[pw_underwater] = 1050
			end
			if p.powers[pw_spacetime] > 0
				p.powers[pw_spacetime] = 403
			end
		end
		
		--canarivore gas handling
		if p.canarivoregassed
			p.canarivoregassed = $ -1
		end
		
		-------------
		----GLIDE----
		-------------
		
		--print(P_GetMobjGravity(p.mo))
		
		--set gravity factor for glide ratio
		if abs(P_GetMobjGravity(p.mo)) <= FRACUNIT/2
			p.gravfactor = abs(P_GetMobjGravity(p.mo))*2
			if P_GetMobjGravity(p.mo) == 0 then p.gravfactor = 0 end
		else
			p.gravfactor = FRACUNIT
		end
		
		--base glide ratio
		p.glideratio = 4*p.gravfactor --proper glide ratio is 20:4 or 5:1
		
		--whirlwind shield caps glide cooldown and optimizes glide ratio
		if (p.powers[pw_shield] == SH_WHIRLWIND)
			p.glideratio = 1*p.gravfactor
			if p.glidecooldown > (1*TICRATE)+(TICRATE/4)
				p.glidecooldown = (1*TICRATE)+(TICRATE/4) -- ~1.25sec
			end
			if p.shieldcooldown > (1*TICRATE)+(TICRATE/4)
				p.shieldcooldown = (1*TICRATE)+(TICRATE/4) -- ~1.25sec
			end
		end
		
		--supermode optimzes glide ratio so that spyro will barely descend
		--it also set's the glide cooldown to zero, effectively allowing spyro to return to gliding asap
		if (p.powers[pw_super] > 0)
			p.glideratio = p.gravfactor/3
			p.glidecooldown = 0
			p.shieldcooldown = 0
		end
		
		--zero out glide cooldown when on ground or springed or underwater
		if P_IsObjectOnGround(p.mo) 
		or (p.mo.eflags & MFE_SPRUNG) 
		or (p.mo.eflags & MFE_UNDERWATER)
		and not p.dirk_frozen
		and not p.mo.frostburnt
		and not p.frozen
			p.glidecooldown = 0
		end
		
		--stop glide
		if p.gliding
		and p.mo.eflags & MFE_SPRUNG
		or P_IsObjectOnGround(p.mo) 
		or p.aircharging 
		or p.glidecooldown > 0
		or p.powers[pw_carry]
		or P_IsObjectInGoop(p.mo) 
		or P_InQuicksand(p.mo) 
		or (p.mo.eflags & MFE_UNDERWATER)
		or p.bannedvars
		or p.isjettysyn
		or valueInTable(p.mo.state, bannedStates)
			p.gliding = false
			p.glidetime = 0
		end
		
		--glide
		if p.gliding
		
			--break glide if caught in wind/current
			--if GetSecSpecial(p.mo.subsector.sector.special, 3) == 2
			--if GetSecSpecial(P_PlayerTouchingSectorSpecial(p, 0, 0), 3) == 2
			--	p.mo.state = S_PLAY_PAIN
			--	p.gliding = false
			--end
		
		
			--get up to glide speed
			--if (p.speed < FixedMul(speedmul, FixedMul(p.glidespeed, p.mo.scale))) 
			if p.speed < ScaledSpeedMul(p.glidespeed)
			and not p.canarivoregassed
				--P_Thrust(p.mo, p.mo.angle, FixedMul(FixedMul(speedmul, p.glidespeed), p.mo.scale) - p.speed) 
				P_Thrust(p.mo, p.mo.angle, ScaledSpeedMul(p.glidespeed) - p.speed)
			end
			
			--norm gravity
			if not p.gravflip
				--start glideslope proper when descending
				if p.mo.momz < FixedMul(1*FRACUNIT, p.mo.scale)
					--p.mo.momz = p.glideratio * -1
					P_SetObjectMomZ(p.mo, p.glideratio * -1, false)
				end
				if p.aircharging
					p.gliding = false
				end
				
				--play glide anim
				if p.mo.state ~= S_PLAY_GLIDE_LOW and p.mo.z - p.mo.floorz <= 32*p.mo.scale and p.mo.momz <= 0
					p.mo.state = S_PLAY_GLIDE_LOW
				elseif p.mo.state ~= S_PLAY_GLIDE and p.mo.z - p.mo.floorz > 32*p.mo.scale and p.mo.momz <= 0
					p.mo.state = S_PLAY_GLIDE
				elseif p.mo.state ~= S_PLAY_FLY and p.mo.momz > 0
					p.mo.state = S_PLAY_FLY
				end
				
			--flipped grav	
			else
				--start glideslope proper when descending
				if p.mo.momz > FixedMul(-1*FRACUNIT, p.mo.scale)
					--p.mo.momz = p.glideratio * 1
					P_SetObjectMomZ(p.mo, p.glideratio * -1, false)
				end
				if p.aircharging
					p.gliding = false
				end
				
				--play glide anim
				if p.mo.state ~= S_PLAY_GLIDE_LOW and p.mo.ceilingz - (p.mo.z+p.mo.height) <= 32*p.mo.scale and p.mo.momz >= 0
					p.mo.state = S_PLAY_GLIDE_LOW
				elseif p.mo.state ~= S_PLAY_GLIDE and p.mo.ceilingz - (p.mo.z+p.mo.height) > 32*p.mo.scale and p.mo.momz >= 0
					p.mo.state = S_PLAY_GLIDE
				elseif p.mo.state ~= S_PLAY_FLY and p.mo.momz < 0
					p.mo.state = S_PLAY_FLY
				end
			end
			
			--super mode enables multi-jump (for a ghetto superfly)
			if p.jumptap and p.gliding and (p.powers[pw_super] > 0)
			and not P_IsObjectOnGround(p.mo)
				--P_DoJumpShield(p)
				P_SetObjectMomZ(p.mo, FixedMul(10*FRACUNIT, p.mo.scale))
				S_StartSound(p.mo, sfx_hover)
				--p.mo.state = S_PLAY_FLY
			end
			
			--increase glidetime, for whoever is cheching this var for whatever reason
			p.glidetime = $ +1
			
			--set drawangle to current velocity direction
			p.drawangle = R_PointToAngle2(p.mo.x, p.mo.y, p.mo.x + p.mo.momx, p.mo.y + p.mo.momy)
			
			--end glide (HOVER)
			if p.custom2tap and not valueInTable(p.mo.state, bannedStates)
			and not p.bannedvars
			and not p.isjettysyn
				p.hovering = 2
				P_InstaThrust(p.mo, p.mo.angle, FixedMul(1*FRACUNIT, p.mo.scale))
				S_StartSound(p.mo, sfx_hover)
				p.gliding = false
				p.bashready = 10
				p.mo.state = S_PLAY_JUMP
				p.glidecooldown = 3*TICRATE --3 secs
			end
		end
		
		----------------
		----HEADBASH----
		----------------
		if p.bashready == nil then p.bashready = 7 end
		
		--headbash when button tapped, not on grnd, not in a banned state, and less than 3 sec left of iframes
		if (p.bashready <= 0 and p.custom2tap) 
		and not P_IsObjectOnGround(p.mo) 
		and not valueInTable(p.mo.state, bannedStates) 
		and (p.powers[pw_flashing] < 3*TICRATE)
		and not p.powers[pw_carry]
		and not p.bannedvars                                                --and not (p.mo.eflags & MFE_UNDERWATER)
		and not p.isjettysyn
			S_StartSound(p.mo, sfx_basha)
			p.bashing = true
			P_SetObjectMomZ(p.mo, -30*FRACUNIT, false)
			p.mo.state = S_PLAY_ROLL
			p.pflags = $ & ~PF_NOJUMPDAMAGE
			p.bashready = 2*TICRATE
			
			--set shield ability flag
			if p.powers[pw_shield] == (SH_BUBBLEWRAP|SH_ELEMENTAL)
			or (p.powers[pw_shield] & SH_FORCE)
				p.pflags = $ | PF_SHIELDABILITY
				p.shieldcooldown = 1*TICRATE
			end
			
			--force shield halts momentum
			if (p.powers[pw_shield] & SH_FORCE)
				p.mo.momx = 0
				p.mo.momy = 0
				S_StartSound(p.mo, sfx_ngskid)
				--p.mo.momz = 0 --killing momz is dumb
			end
		end
		
		--bashing through bustable floor
		local sectordata = P_PlayerTouchingSectorSpecial(p, 0, 0)
		if sectordata
			for fof in sectordata.ffloors()
				if p.bashing
				and (p.mo.z <= (fof.topheight + p.mo.scale)
				and (p.mo.z + p.mo.height) > fof.bottomheight)
				and (fof.flags & FF_EXISTS) and (fof.flags & FF_BUSTUP)
					EV_CrumbleChain(p.sectordata, fof)
				end
			end
		end
		
		--headbash contact ground
		if P_IsObjectOnGround(p.mo) and p.bashing 
		and not valueInTable(p.mo.state, bannedStates)
		and not p.bannedvars
		and not p.isjettysyn
			
			if not P_InQuicksand(p.mo)
				--rollout move (aka a shitty version of the drop dash)
				if (p.cmd.buttons & BT_USE) and (cv_rolloutavailable.value ~= 0)
					p.pflags = $ | PF_SPINNING
					p.mo.state = S_PLAY_ROLL
					P_InstaThrust(p.mo, p.mo.angle, 15*p.mo.scale)
					p.bashing = false
					p.bashready = 2*TICRATE
				else --otherwise bonk
					S_StartSound(p.mo, sfx_sbonk)
					P_SetObjectMomZ(p.mo, 5*FRACUNIT, false)
					p.mo.momx = $ /2
					p.mo.momy = $ /2
					p.mo.state = S_PLAY_FALL
					p.pflags = $ | PF_NOJUMPDAMAGE
					p.bashing = false
					p.bashready = 2*TICRATE
					
					--do elemental flame circle
					if p.powers[pw_shield] == SH_ELEMENTAL
					or p.powers[pw_super] ~= 0
						P_ElementalFire(p, true)
						P_SetObjectMomZ(p.mo, 1*FRACUNIT, false)
					end
					
					--do bubble bounce
					if p.powers[pw_shield] == SH_BUBBLEWRAP
						P_DoBubbleBounce(p)
						p.bashready = TICRATE/4
						p.mo.state = S_PLAY_JUMP
						--p.shieldcooldown = TICRATE/4
						S_StopSoundByID(p.mo, sfx_sbonk)
					end
					
					--do asplode
					if p.powers[pw_shield] == SH_ARMAGEDDON
					or p.hypermode --hyper abilities, may or may not get annoying quick
					--or p.powers[pw_super] ~= 0
						P_BlackOw(p)
					end
				end
			end
			p.bashing = false
		end
		
		--ascend when hovering
		--fixes some issues where spyro won't ascend in some circumstances
		--such as hitting a ceiling or lag in some cases
		if p.hovering
			P_SetObjectMomZ(p.mo, 10*FRACUNIT, false)
			p.mo.state = S_PLAY_JUMP
			if P_IsObjectOnGround(p.mo) then p.hovering = 0 end
			p.hovering = $ -1
		end
		
		--reset bashready when on ground and bashready is low
		if p.bashready <= (1*TICRATE)+(TICRATE/2) and not p.bashing and P_IsObjectOnGround(p.mo)
			p.bashready = 0
		end
		
		--stop head bash when ascending
		if p.bashing and p.mo.momz > 0 and not p.gravflip
			p.bashing = false
			P_SetObjectMomZ(p.mo, p.mo.momz/3, false)
			p.pflags = $ & ~PF_NOJUMPDAMAGE
			p.bashready = $ /4
			p.glidecooldown = $ /4
			p.mo.state = S_PLAY_JUMP
		elseif p.bashing and p.mo.momz < 0 and p.gravflip
			p.bashing = false
			P_SetObjectMomZ(p.mo, p.mo.momz/3, false)
			p.pflags = $ & ~PF_NOJUMPDAMAGE
			p.bashready = $ /4
			p.glidecooldown = $ /4
			p.mo.state = S_PLAY_JUMP
		end
		
		--reset glidecooldown if somehow launched faster than your hover momentum
		--or springed or carried
		if (p.mo.momz > 10*p.mo.scale and not p.gravflip)
		or (p.mo.momz < -10*p.mo.scale and p.gravflip)
		or p.powers[pw_carry]
		or (p.mo.eflags & MFE_SPRUNG)
		and p.glidecooldown > 0
			p.glidecooldown = 0
		end
		
		--clear thokked/shieldability flag when shieldcooldown is off
		if not p.shieldcooldown
		--and ((p.mo.momz > 1*p.mo.scale and not p.gravflip) or (p.mo.momz < -1*p.mo.scale and p.gravflip))
		--and not p.powers[pw_shield] == (SH_BUBBLEWRAP|SH_ELEMENTAL)
		and (p.pflags & (PF_THOKKED|PF_SHIELDABILITY))
			p.pflags = $ & ~PF_THOKKED
			p.pflags = $ & ~PF_SHIELDABILITY
		end
		
		--decrement vars
		if p.glidecooldown > 0 then p.glidecooldown = $ - 1 end
		if p.shieldcooldown > 0 then p.shieldcooldown = $ - 1 end
		if p.bashready > 0 then p.bashready = $ -1 end
		
		--------------
		----CHARGE----
		--------------
		
		--do we have supercharge?
		if (p.powers[pw_sneakers] > 0) 
		or (p.powers[pw_super] > 0) 
		or p.supercharge --kimiokawaii, bio satelite's supercharge floors
		or p.machspeedmode --sonic 06, mach speed sections
		--or (p.speed > ScaledSpeedMul(p.superchargespeed) and P_IsObjectOnGround(p.mo))
		or (p.speed > ScaledSpeedMul(p.superchargespeed))
			p.supercharging = true
		else
			p.supercharging = false
		end
		
		--chargespeed modifiers based on conditions
		local realchargespeed = p.chargespeed
		--if not P_IsObjectOnGround(p.mo)
		--	realchargespeed = p.airchargespeed
		--end
		if p.supercharging and p.dashmode < 3*TICRATE
			realchargespeed = p.superchargespeed
		end
		if p.supercharging and p.dashmode >= 3*TICRATE
			realchargespeed = p.superchargedashspeed
		end
		if p.canarivoregassed
			realchargespeed = $ /3
		end
		if p.mo.eflags & MFE_UNDERWATER
			realchargespeed = FixedMul(realchargespeed, (FRACUNIT/10)*7)
		end
		
		--charge
		if ((p.cmd.buttons & BTn_USE) or p.machspeedmode or (p.mo.state == S_PLAY_FALLCHARGE and not (p.mo.eflags & (MFE_UNDERWATER|MFE_GOOWATER))))
		and not valueInTable(p.mo.state, bannedStates) 
		and not (p.pflags & PF_SPINNING) 
		and (p.exiting == 0) 
		and not(P_IsObjectInGoop(p.mo) or P_InQuicksand(p.mo))
		and p.powers[pw_carry] == 0
		and p.chargecooldown <= 0
		and not p.slowgooptimer --mystic realm ce, slowgoop
		and not p.bannedvars
		and not p.isjettysyn
			--new aceel/thurst handling based on whirl
			local accel = 6
			local thrust = min(p.speed+(accel*p.mo.scale), ScaledSpeedMul(realchargespeed))
			
			--accleration modifiers based on conditions
			if p.canarivoregassed
				accel = $ / 6
			end
			if p.mo.eflags & MFE_UNDERWATER
				accel = $ / 4
			end
			
			--p.normalspeed = FixedMul(cv_spyrospeedmul.value, realchargespeed)
			p.runspeed = 0
			
			--ground charge
			if P_IsObjectOnGround(p.mo) --or p.speed > ScaledSpeedMul(p.chargespeed)
				--play sound
				if not S_SoundPlaying(p.mo, sfx_charge) 
				and not (p.mo.eflags & (MFE_UNDERWATER | MFE_GOOWATER))
				and not p.supercharging
				and P_IsObjectOnGround(p.mo)
					S_StartSound(p.mo, sfx_charge)
				end
				
				if not S_SoundPlaying(p.mo, sfx_scharg) 
				and p.supercharging
				and P_IsObjectOnGround(p.mo)
					S_StartSound(p.mo, sfx_scharg)
				end
				
				--force into a spin if springed or on a speedpad while charging
				if ((p.mo.eflags & MFE_SPRUNG) or GetSecSpecial(p.mo.subsector.sector.special, 3) == 5)
				and (p.charging or p.aircharging)
				--and p.speed > FixedMul(p.chargespeed, cv_spyrospeedmul.value)
					p.pflags = $ | PF_SPINNING
					p.mo.state = S_PLAY_ROLL
					p.charging = false
					p.aircharging = false
					return --we return out of the code block b/c i can't into good flow
				end
				
				p.charging = true
				p.aircharging = false
				--conveyor shenanigans
				if p.onconveyor
					p.mo.momx = P_ReturnThrustX(nil, p.drawangle, thrust)+p.cmomx
					p.mo.momy = P_ReturnThrustY(nil, p.drawangle, thrust)+p.cmomy
				--actual thrust
				elseif (p.cmd.buttons & BTn_USE)
				and p.speed < ScaledSpeedMul(realchargespeed)
				--and p.speed < realchargespeed
					P_InstaThrust(p.mo, p.mo.angle, thrust)
					--p.normalspeed = FixedMul(cv_spyrospeedmul.value, realchargespeed)
				end
				
				--supercharge
				if p.supercharging
					--play sound
					if not S_SoundPlaying(p.mo, sfx_scharg)
					and P_IsObjectOnGround(p.mo)
						S_StartSound(p.mo, sfx_scharg)
					end
					
					--spawn dust trail
					if p.supercharging
					--and p.speed >= ScaledSpeedMul(p.superchargespeed)
					and (p.mo.state == S_PLAY_RUN or p.mo.state == S_PLAY_DASH)
					and P_IsObjectOnGround(p.mo)
					and not (p.mo.eflags & (MFE_UNDERWATER | MFE_GOOWATER))
					and (leveltime % 2) == 0 --every 2 tics 
						local dust = P_SpawnMobjFromMobj(p.mo, 0, 0, p.mo.scale * 2, MT_SPINDUST)
						P_SetObjectMomZ(dust, 2*FRACUNIT)
					end
					
					--give dashmode stuff when supercharging
					if not p.machspeedmode --sonic 06 machspeed diddles with the dashmode flags
						p.charflags = $ | SF_DASHMODE
						p.charflags = $ | SF_MACHINE --beep beep boop bzzt i can now go thru spikes
						p.charflags = $ | SF_RUNONWATER
					else
						p.charflags = $ | SF_RUNONWATER
					end
					
					--tweak dashmode counter so we can get into dashmode earlier
					if (p.charflags & SF_DASHMODE)
						--print(p.dashmode)
						
						if p.powers[pw_super] > 0 --super is special
						or p.speed > ScaledSpeedMul(60*FRACUNIT) --or if spyro is somehow going fast enough
						and p.dashmode < (3*TICRATE) --3sec
							p.dashmode = (4*TICRATE) --dashmode will happen almost immedietly
						end
						
						if p.dashmode < (TICRATE)+(TICRATE/2) --1.5sec
							p.dashmode = (TICRATE)+(TICRATE/2) --dashmode will take half as long to get into effect
						end
					end
					
					--create fire trail when super or in dash mode
					if (p.powers[pw_super] > 0 or p.dashmode >= 3*TICRATE)
					and (leveltime % 2) == 0 --every 2 tics 
						P_ElementalFire(p, false)
					end	
				end	
			--aircharge
			else
				p.charging = false
				p.aircharging = true
				
				--actual thrust
				if p.speed < ScaledSpeedMul(p.airchargespeed)
					P_InstaThrust(p.mo, p.mo.angle, thrust)
				elseif p.speed > ScaledSpeedMul(p.airchargespeed)
				and p.speed < ScaledSpeedMul(p.superchargespeed)
				and ((p.mo.momz < 0 and not p.gravflip) or (p.mo.momz > 0 and p.gravflip))
				and not p.supercharging
				and not(p.powers[pw_shield] == SH_FLAMEAURA and (p.pflags & PF_SHIELDABILITY))
					P_Thrust(p.mo, p.mo.angle, FixedMul((-3*FRACUNIT)/8, p.mo.scale))
				end
				
				--force into a pain spin if springed while charging
				if (p.mo.eflags & MFE_SPRUNG)
				and (p.charging or p.aircharging)
				--and p.speed > FixedMul(p.chargespeed, cv_spyrospeedmul.value)
					p.pflags = $ | PF_SPINNING
					p.mo.state = S_PLAY_PAIN
					p.charging = false
					p.aircharging = false
					return --we return out of the code block b/c i can't into good flow
				end
				
				--descend
				if p.powers[pw_shield] ~= SH_FLAMEAURA
				and not (p.pflags & PF_SHIELDABILITY)
					if p.mo.momz < 0 and not p.gravflip
						p.mo.momz = $ - FixedMul((FRACUNIT*3)/8, p.mo.scale)
					elseif p.mo.momz > 0 and p.gravflip
						p.mo.momz = $ + FixedMul((FRACUNIT*3)/8, p.mo.scale)
					end
				end
				
				--play animation
				if (p.mo.state ~= S_PLAY_FALLCHARGE) or (p.mo.state ~= S_PLAY_SWIMCHARGE)
				--and not(mapheaderinfo[gamemap].typeoflevel & (TOL_NIGHTS|TOL_XMAS))
					if (p.mo.eflags & (MFE_UNDERWATER | MFE_GOOWATER))
						p.mo.state = S_PLAY_SWIMCHARGE
					end
					
					if p.aircharging and not P_IsObjectOnGround(p.mo) and not(p.mo.eflags & (MFE_UNDERWATER | MFE_GOOWATER))
					--and not(mapheaderinfo[gamemap].typeoflevel & (TOL_NIGHTS|TOL_XMAS))
						p.mo.state = S_PLAY_FALLCHARGE
					end
				end
			end
			
			--tweak jumpfactor when charging
			if p.mo.pw_springsocks --esp (extra shield powers)
				p.jumpfactor = (p.chargejumpfactor * 4)/3
			else
				p.jumpfactor = p.chargejumpfactor
			end
			/*
			--play underwater charge sound
			if (p.mo.eflags & (MFE_UNDERWATER | MFE_GOOWATER))
			and p.realtime % 5 == 0
				--S_StartSound(p.mo, sfx_floush)
				S_StartSound(p.mo, bubblesnd[P_RandomKey(#bubblesnd)+1])
			end
			*/
			--play animation
			if p.mo.state ~= S_PLAY_RUN 
			and P_IsObjectOnGround(p.mo) 
			and (p.cmd.forwardmove or p.cmd.sidemove)
			and not valueInTable(p.mo.state, bannedStates)
				p.mo.state = S_PLAY_RUN
			end
			
			--angle shenanigans to mess w/ kbm users
			p.mo.angle = p.chargeangle
			--p.drawangle = p.mo.angle
			
			--sidemove steering stuff
			if p.cmd.sidemove
				if P_IsObjectOnGround(p.mo)
					p.chargeangle = $ - (p.cmd.sidemove*ANG1)/15
				else
					p.chargeangle = $ - (p.cmd.sidemove*ANG1)/30
				end
			end
			if p.mousedx
			and p.speed and p.mo.linecollide == nil
				if P_IsObjectOnGround(p.mo)
					p.chargeangle = $ + p.clampedmousedx
				else
					p.chargeangle = $ + p.clampedmousedx/2
				end
			end
			
		--not charging
		else--if leveltime % (TICRATE/10) == 0
			p.charging = false
			p.aircharging = false
			--p.normalspeed = skins[p.mo.skin].normalspeed
			p.normalspeed = FixedMul(cv_spyrospeedmul.value, p.walkspeed)
			--p.runspeed = p.normalspeed + (25*FRACUNIT)
			p.runspeed = p.chargespeed + 50
			p.chargeangle = p.mo.angle
			
			--tweak jumpfactor
			if p.mo.pw_springsocks --esp
				p.jumpfactor = (p.normaljumpfactor * 4)/3
			else
				p.jumpfactor = p.normaljumpfactor
			end
			
			--switch to fall anim (just in case)
			if not P_IsObjectOnGround(p.mo) 
			and p.mo.state == S_PLAY_FALLCHARGE
				p.mo.state = S_PLAY_FALL
			end
		end
		
		--stop charging when in a pain state
		if p.mo.state == P_PLAY_PAIN
			p.charging = false
			p.aircharging = false
		end
		
		--stop sounds
		if not p.charging 
		or not P_IsObjectOnGround(p.mo)
		and S_SoundPlaying(p.mo, sfx_charge)
			--S_StopSound(p.mo)
			S_StopSoundByID(p.mo, sfx_charge)
		end
		if not p.charging 
		or not P_IsObjectOnGround(p.mo)
		and S_SoundPlaying(p.mo, sfx_scharg)
			--S_StopSound(p.mo)
			S_StopSoundByID(p.mo, sfx_scharg)
		end
		
		--get rid of dashmode stuff when not supercharging
		if not p.supercharging
		and p.charflags & SF_DASHMODE
		or (not(p.charging or p.aircharging) and (p.charflags & SF_DASHMODE))
			if p.mo.state == S_PLAY_DASH 
				p.mo.state = S_PLAY_WALK 
			end
			p.charflags = $ & ~SF_DASHMODE
			p.charflags = $ & ~SF_MACHINE
			p.charflags = $ & ~SF_RUNONWATER
		end
		
		--stop aircharging when on ground
		if P_IsObjectOnGround(p.mo)
			p.aircharging = false
		end
		
		--don't 'charge' above ground
		if not P_IsObjectOnGround(p.mo)
		and p.charging
			p.charging = false
		end
		
		--decrement vars
		if p.chargecooldown then p.chargecooldown = $ -1 end
		
		----------------------
		----BREATH ATTACKS----
		----------------------
		
		--superflame stuff, available with shields that protect from fire or while super
		/*
		if not p.flamed and not (p.charging and p.aircharging and p.bashing)
		--if not (p.charging or p.aircharging or p.bashing)
		--and p.custom1tap and not valueInTable(p.mo.state, bannedStates) 
		and (p.cmd.buttons & BT_CUSTOM1) and not valueInTable(p.mo.state, bannedStates) 
		and p.exiting == 0 
		and ((p.powers[pw_shield] & SH_PROTECTFIRE) or p.powers[pw_super] ~= 0 or p.elemtimer)
		and p.sflamecooldown <= 0
		--and not p.dirk_frozen --dirk
		--and not p.iseggrobo --battlemod
		and not p.bannedvars
		*/
		
		--are we in first person view? if so then we can aim
		--force canim off in netgames cuz sync issues.
		if netgame
			p.canaim = 0
		elseif chasecam_on
			p.canaim = 0
		else
			p.canaim = 1
		end
		
		--can we hold the custom1 button?
		if (p.cmd.buttons & BT_CUSTOM1)
		and cv_spyroholdflame.value == 1
			holdflame = true
		else
			holdflame = false
		end
		
		--superflame
		if (p.cmd.buttons & BT_CUSTOM1)
		and not p.flamed
		and not (p.charging or p.aircharging or p.bashing)
		and p.sflamecooldown <= 0
		and ((p.powers[pw_shield] & SH_PROTECTFIRE) or p.powers[pw_super] ~= 0 or p.elemtimer)
		and not p.bannedvars
		
			--p.sflamemo = P_SPMAngle(p.mo, MT_SPYROFIRESUPER, p.drawangle, 1, MF2_EXPLOSION)
			P_SPMAngle(p.mo, MT_SPYROFIRESUPER, p.drawangle, p.canaim, MF2_EXPLOSION)
			--give superflame explosive properties
			--if p.sflamemo
			--	p.sflamemo.flags2 = $ | MF2_EXPLOSION
			--end
			S_StartSound(p.mo, sfx_sflame)
			--p.sflamecooldown = 9
			p.sflamecooldown = (TICRATE*4)/10
			p.flamed = true
			
			--play anim
			if P_IsObjectOnGround(p.mo) 
			and (p.mo.state & (PA_IDLE|PA_EDGE|S_PLAY_WAIT) and p.mo.momx == 0 and p.mo.momy == 0)
				p.mo.state = S_PLAY_FIRE
			end
			
			--return
		end
		
		--electric breath stuff, available with shields that protect from electricity such as the attraction shield and electric shield
		--electric breath chargeup
		if p.cmd.buttons & BT_CUSTOM1
		and not valueInTable(p.mo.state, bannedStates) 
		and p.exiting == 0 and (p.powers[pw_shield] & SH_PROTECTELECTRIC)
		and p.sflamecooldown <= 0
		and not p.bannedvars
			
			--print(p.shootcharge)
			p.shootcharge = $ +1
			--play chargeup sound
			if (p.shootcharge > 5 and p.shootcharge < 35) and not S_SoundPlaying(p.mo, sfx_echarg)
				S_StartSound(p.mo, sfx_echarg)
			end
			
			--play sound when ready
			if p.shootcharge >= 48
				S_StartSound(p.mo, sfx_s3ka6)
			end
			
			--cap shootcharge
			if p.shootcharge > 50 then p.shootcharge = 50 end
			
			--return
		end
		
		--charged super elecball shot upon button release when charged up
		if not p.flamed and not p.charging and not p.aircharging and not p.bashing 
		and not (p.cmd.buttons & BT_CUSTOM1)
		and not valueInTable(p.mo.state, bannedStates) 
		and p.exiting == 0 and (p.powers[pw_shield] & SH_PROTECTELECTRIC)
		and p.sflamecooldown <= 0
		and not p.bannedvars
		and p.shootcharge > 0
			
			--shoot power bolt when charged up along with a stream of regular elec bolts, megaman style
			if p.shootcharge >= 40
				P_SPMAngle(p.mo, MT_SPYROELEC2, p.drawangle, p.canaim)
				--P_SPMAngle(p.mo, MT_SPYROELEC1, p.drawangle, 1)
				S_StartSound(p.mo, sfx_selec2)
				p.sflamecooldown = 9
				p.flameTimer = p.shootcharge/2
				p.shootcharge = 0
				p.chargeshot = true
				
				--play anim
				if P_IsObjectOnGround(p.mo) 
				and (p.mo.state & (PA_IDLE|PA_EDGE|S_PLAY_WAIT) and p.mo.momx == 0 and p.mo.momy == 0)
				and not p.bannedvars
					p.mo.state = S_PLAY_FIRE
				end
			else
				p.flameTimer = p.shootcharge/2
				p.shootcharge = 0
				
				--play anim
				if P_IsObjectOnGround(p.mo) 
				and (p.mo.state & (PA_IDLE|PA_EDGE|S_PLAY_WAIT) and p.mo.momx == 0 and p.mo.momy == 0)
				and not p.bannedvars
					p.mo.state = S_PLAY_FIRE
				end
			end
			
			--return
		end
		
		--elec breath stream
		if not p.flamed and not p.charging and not p.aircharging and not p.bashing 
		and p.custom1tap and not valueInTable(p.mo.state, bannedStates) 
		and p.exiting == 0 and (p.powers[pw_shield] & SH_PROTECTELECTRIC) 
		and p.sflamecooldown <= 0
		and not p.bannedvars
			
			P_SPMAngle(p.mo, MT_SPYROELEC1, p.drawangle, p.canaim)
			S_StartSound(p.mo, sfx_selec1)
			p.sflamecooldown = 3
			
			--play anim
			if P_IsObjectOnGround(p.mo) 
			and (p.mo.state & (PA_IDLE|PA_EDGE|S_PLAY_WAIT) 
			and p.mo.momx == 0 and p.mo.momy == 0)
			and not p.bannedvars
				p.mo.state = S_PLAY_FIRE
			end
			
			--return
		end
		
		--reset elec shot chargeup when elec shield lost
		if not (p.powers[pw_shield] & SH_PROTECTELECTRIC) then p.shootcharge = 0 end
		
		--stop chargeup sound
		if not p.shootcharge and S_SoundPlaying(p.mo, sfx_echarg)
			--S_StopSound(p.mo)
			S_StopSoundByID(p.mo, sfx_echarg)
		end
		
		--fire breath stuff
		if not p.flamed and not p.charging and not p.aircharging and not p.bashing
		--and p.cmd.buttons & BT_CUSTOM1 
		and (p.custom1tap or holdflame)
		and not valueInTable(p.mo.state, bannedStates)
		and not p.bannedvars
		and p.exiting == 0
		
			p.flamed = true
			--if p.superflame == true
			--	S_StartSound(p.mo, sfx_sflame, p)
			--	return
			--end
			if not (p.mo.eflags & MFE_UNDERWATER)
			and not ((p.powers[pw_shield] & (SH_PROTECTFIRE|SH_PROTECTELECTRIC)) or p.elemtimer)
				S_StartSound(p.mo, sfx_flame)
			end
			--if not (p.mo.pflags & PF_THOKKED)
			--	p.mo.eflags = $ | PF_THOKKED
			--end
			if not (p.powers[pw_shield] & SH_PROTECTELECTRIC)
				p.flameTimer = 20
			end
		end
		
		--spew flames when flametimer has time and not have elec shield
		if p.flameTimer	
			if (p.flameTimer % 3) == 0 --every 3 tics
			and not ((p.powers[pw_shield] & (SH_PROTECTFIRE|SH_PROTECTELECTRIC)) or p.elemtimer)
					
				if p.mo.eflags & MFE_UNDERWATER --underwater bubbles
					P_SPMAngle(p.mo, MT_SPYROBUBBLE, (p.drawangle - (ANGLE_45 / 4)), p.canaim)
					P_SPMAngle(p.mo, MT_SPYROBUBBLE, (p.drawangle - (ANGLE_45 / 8)), p.canaim)
					P_SPMAngle(p.mo, MT_SPYROBUBBLE, p.drawangle, p.canaim)
					P_SPMAngle(p.mo, MT_SPYROBUBBLE, (p.drawangle + (ANGLE_45 / 8)), p.canaim)
					P_SPMAngle(p.mo, MT_SPYROBUBBLE, (p.drawangle + (ANGLE_45 / 4)), p.canaim)
					S_StartSound(p.mo, bubblesnd[P_RandomKey(#bubblesnd)+1])
					if p.powers[pw_underwater] > 10 then p.powers[pw_underwater] = $ -10 end -- >:)
					
				elseif not (p.powers[pw_shield] & SH_PROTECTELECTRIC) --normal flames
					P_SPMAngle(p.mo, MT_SPYROFIRE, (p.drawangle - (ANGLE_45 / 4)), p.canaim)
					P_SPMAngle(p.mo, MT_SPYROFIRE, (p.drawangle - (ANGLE_45 / 8)), p.canaim)
					P_SPMAngle(p.mo, MT_SPYROFIRE, p.drawangle, p.canaim)
					P_SPMAngle(p.mo, MT_SPYROFIRE, (p.drawangle + (ANGLE_45 / 8)), p.canaim)
					P_SPMAngle(p.mo, MT_SPYROFIRE, (p.drawangle + (ANGLE_45 / 4)), p.canaim)
				end
			end
			
			if (p.flameTimer > 0) --elec bolts
			and not p.chargeshot
			and (p.powers[pw_shield] & SH_PROTECTELECTRIC)
				P_SPMAngle(p.mo, MT_SPYROELEC1, p.drawangle, p.canaim)	
				S_StartSound(p.mo, sfx_s3ka6)
			end
			
			p.flameTimer = $ - 1
			p.chargeshot = false
			
			--play anim
			if P_IsObjectOnGround(p.mo) 
			and (p.mo.state & (PA_IDLE|PA_EDGE|S_PLAY_WAIT) and p.mo.momx == 0 and p.mo.momy == 0)
			and not p.bannedvars
			and not p.isjettysyn
				p.mo.state = S_PLAY_FIRE
			end
		end
		
		if p.sflamecooldown > 0 then p.sflamecooldown = $ -1 end
		
		--print(p.sflamecooldown)
		
		if not p.flameTimer
			p.flamed = false
		end
		
		--p.drawangle = p.mo.angle
		
		------------
		----SWIM----
		------------
		--more usefull swimming
		if (p.mo.eflags & MFE_UNDERWATER) 
		and not(p.pflags & PF_JUMPED) 
		and not P_IsObjectOnGround(p.mo) 
		and not valueInTable(p.mo.state, bannedStates)
		and not p.bannedvars
		and not p.isjettysyn
		and not p.powers[pw_carry]
			p.pflags = $ | PF_JUMPED
		end
		
		--add no jump damage flag when swimming
		if  p.mo.state == S_PLAY_SWIM 
		and not (p.pflags & PF_NOJUMPDAMAGE)
			p.pflags = $ | PF_NOJUMPDAMAGE
		end
		if (p.mo.eflags & MFE_UNDERWATER) 
		and (p.cmd.buttons & BT_JUMP) 
		and not P_IsObjectOnGround(p.mo) 
		and not valueInTable(p.mo.state, bannedStates) 
		and not (p.charging or p.aircharging) 
		and not (P_IsObjectInGoop(p.mo) or P_InQuicksand(p.mo))
		and not valueInTable(p.mo.state, bannedStates)
		and not p.bannedvars
		and not p.isjettysyn
		and not p.powers[pw_carry]
			--play swim anim when not in nights levels
			if not(mapheaderinfo[gamemap].typeoflevel & (TOL_NIGHTS|TOL_XMAS))
				p.mo.state = S_PLAY_SWIM
				p.panim = PA_ABILITY
			end
			--ascend
			if (p.mo.momz < 5*FRACUNIT and not p.gravflip)
			or (p.mo.momz > 5*FRACUNIT and p.gravflip)
				--P_SetObjectMomZ(p.mo, 1*(FRACUNIT/4), true)
				P_SetObjectMomZ(p.mo, 1*(FRACUNIT/2), true)
			end
		end
	end
end)
/*
--player charging damage (OLD)
addHook("MobjMoveCollide", function(mo, enemy)
	if mo.skin == "spyro" 
	and (mo.player.charging or mo.player.aircharging)
	and enemy and enemy.valid
	
		--don't proc if we vertically miss
		if(enemy.z > mo.z+mo.height) or (mo.z > enemy.z+enemy.height+(2*FRACUNIT))
			return nil
		end
		
		--special handling for pointy enemies (red & gold buzzes)
		if(enemy.type == MT_GOLDBUZZ or enemy.type == MT_REDBUZZ)
		and mo.player.powers[pw_flashing] == 0
		and mo.player.powers[pw_invulnerability] == 0
		and mo.player.powers[pw_super] == 0
		and not mo.player.homing
		and not mo.player.supercharging
			--don't proc if we vertically miss
			if(enemy.z > mo.z+mo.height) or (mo.z > enemy.z+enemy.height+(2*FRACUNIT))
				return nil
			end
			S_StartSound(mo, sfx_spkdth) --all this to play a sound???
			return nil
		end
		
		--object checking
		if enemy.flags & (MF_MONITOR|MF_ENEMY|MF_BOSS)
		--and not valueInTable(enemy.type, nonchargeableEnemies)
		or mo.player.supercharging
			
			--don't proc if we vertically miss
			if(enemy.z > mo.z+mo.height) or (mo.z > enemy.z+enemy.height+(2*FRACUNIT))
				return nil
			end
			
			--special handling for egg collosseum eggman
			if (mo.player.charging or mo.player.aircharging)
			and enemy.type == MT_EGGMOBILE4
				mo.player.charging = false
				mo.player.aircharging = false
				mo.player.powers[pw_nocontrol] = TICRATE/2
				mo.player.powers[pw_flashing] = TICRATE*2
				mo.angle = R_PointToAngle2(enemy.x, enemy.y, 0, 0)
				P_InstaThrust(mo, mo.angle + ANGLE_180, 36*mo.scale)
				--mo.player.pflags = $ | PF_SPINNING
				P_SetObjectMomZ(mo, 6*mo.scale)
				mo.state = S_PLAY_ROLL
				--P_DamageMobj(enemy, mo, mo, 1)
				return nil
			end
			
			--special handling for egg guard's eggshield
			if enemy.type == MT_EGGSHIELD
				enemy.target = mo
				return
			end
			
			--speical handling for spikes
			if (mo.player.charging or mo.player.aircharging)
			and (enemy.type == MT_SPIKE or enemy.type == MT_WALLSPIKE)
			and mo.player.supercharging
				P_KillMobj(enemy, mo)
				return
			end
			
			--special handling for gem containers (chests, vases, baskets, etc.)
			if constantExists("MT_SPYRO_BASKET")
				if enemy.type == MT_SPYRO_BASKET --requires a special fixed version of the basket code, otherwise it does fuck-all but play sounds
					enemy.charged = true --supposed to set spawned gem as 'marked' and not 'airborne' to enable homing
					enemy.charger = mo --target for the marked gem to home in on
					S_StartSound(enemy, sfx_bskbrk)
				end
				return
			end
			
			--bonk both player and enemy player if they're both charging
			if enemy.player and (enemy.player.charging or enemy.player.aircharging or enemy.player.whirlram)
				P_DoPlayerPainNoIframe(p)
				mo.player.charging = false
				mo.player.aircharging = false
				P_DoPlayerPainNoIframe(enemy.player)
				enemy.player.charging = false
				enemy.player.aircharging = false
				enemy.player.whirlram = false --dirkchar, whirl
				S_StopSoundByID(enemy, sfx_s3kcfl) --dirkchar
				S_StartSound(mo.player, sfx_sbonk)
				return nil
			end
			
			--bonking against bonkable playerskins, no harm
			if (enemy.player and valueInTable(enemy.skin, chargeableBonk))
			and not mo.player.supercharging
				P_DoPlayerPainNoIframe(mo.player)
				S_StartSound(mo, sfx_s3k49)
				return nil
			end
			
			--bonking against bonkables
			if valueInTable(enemy.type, chargeableBonk)
			and not mo.player.supercharging
				P_DoPlayerPainNoIframe(mo.player)
				S_StartSound(mo, sfx_s3k49)
			end
			
			--supercharging does essentially instakill damage
			--unless you encounter an absolute unit of a mobj with an obscene amount of hp
			if mo.player.supercharging
				P_DamageMobj(enemy, mo, mo, 100)
				return nil
			end
			
			if not valueInTable(enemy.type, nonchargeableEnemies)
				P_DamageMobj(enemy, mo, mo, 1)
			end
		end
	end
end)
*/

--charge collision check
addHook("MobjMoveCollide", function(mo, enemy)
	if mo.player and mo.skin == "spyro"
		--special handling for canarivore gas
		if enemy and enemy.valid and enemy.type == MT_CANARIVORE_GAS
			--don't proc if we vertically miss
			if(enemy.z > mo.z+mo.height) or (mo.z > enemy.z+enemy.height+(2*FRACUNIT))
				return nil
			end
			
			mo.player.canarivoregassed = 2
		end
		
		--normal charge collision checks
		if (mo.player.charging or mo.player.aircharging)
		and enemy and enemy.valid
		and R_PointToAngle2(mo.x, mo.y, enemy.x, enemy.y) - mo.player.drawangle <= ANGLE_90
			local p = mo.player
			--don't proc if we vertically miss
			if(enemy.z > mo.z+mo.height) or (mo.z > enemy.z+enemy.height+(2*FRACUNIT))
				return nil
			end
			
			--print(enemy.weight)
			--just in case if battlemod wasn't initialized
			if p.mo.weight == nil then p.mo.weight = FRACUNIT end
			if enemy.weight == nil then enemy.weight = FRACUNIT -1 end
			
			--to avoid bonking against monitors
			if enemy.flags & MF_MONITOR
				P_DamageMobj(enemy, mo, mo, 1)
				return false
			end
			
			--speical handling for spikes
			if (enemy.type == MT_SPIKE or enemy.type == MT_WALLSPIKE)
			and p.mo.player.mo.player.mo.player.mo.player.mo.player.mo.player.mo.player.supercharging -- :^)
				P_KillMobj(enemy, p.mo)
				return nil
			end
			
			--special handling for gem containers (chests, vases, baskets, etc.)
			if constantExists("MT_SPYRO_BASKET")
				if enemy.type == MT_SPYRO_BASKET --requires a special fixed version of the basket code, otherwise it does fuck-all but play sounds
					enemy.charged = true --supposed to set spawned gem as 'marked' and not 'airborne' to enable homing
					enemy.charger = mo --target for the marked gem to home in on
					S_StartSound(enemy, sfx_bskbrk)
				end
				return
			end
			
			--bonk both player and enemy player if they're both charging
			if enemy.player and (enemy.player.charging or enemy.player.aircharging or enemy.player.whirlram)
				P_DoPlayerPainNoIframe(p)
				mo.player.charging = false
				mo.player.aircharging = false
				P_DoPlayerPainNoIframe(enemy.player)
				enemy.player.charging = false
				enemy.player.aircharging = false
				enemy.player.whirlram = false --dirkchar, whirl
				S_StopSoundByID(enemy, sfx_s3kcfl) --dirkchar
				S_StartSound(mo, sfx_sbonk)
				return nil
			end
			
			--bonking against bonkable playerskins, no harm
			if enemy.type == MT_PLAYER
			and(enemy.player and valueInTable(enemy.skin, chargeableBonk))
			and not mo.player.supercharging
				P_DoPlayerPainNoIframe(mo.player)
				S_StartSound(mo, sfx_s3k49)
				return nil
			end
			
			--bonking against 'heavy' players (battlemod)
			if enemy.type == MT_PLAYER and enemy.player
			and not mo.player.supercharging
				if enemy.weight > p.mo.weight
				--or (enenmy.player.pflags & PF_SPINNING)
					P_DoPlayerPainNoIframe(mo.player)
					P_DamageMobj(enemy, mo, mo, 1)
				end
			end
		end
	end
end)

--anti-srb1 glitch
--to prevent spyro from randomly getting hit while charging an enemy
addHook("ShouldDamage", function (target, inflictor, src, dmg, dmgtype)
	if target and target.player and target.skin == "spyro"
		local p = target.player
		--don't harm player if they're god
		if (p.pflags & PF_GODMODE)
		or p.powers[pw_super] or p.powers[pw_invulnerability]
			return nil
		end
		
		--do normal checks if using attract shield homing attk
		if p.powers[pw_shield] == SH_ATTACT 
		and (p.pflags & PF_SHIELDABILITY)
			p.charging = false
			p.aircharging = false
			p.mo.momx = $ /2
			p.mo.momy = $ /2
			return nil
		end
		
		if (p.charging or p.aircharging)
		and ((inflictor and inflictor.type and not valueInTable(inflictor.type, nonchargeableEnemies)) or p.supercharging)
		and not (p.pflags & PF_SPINNING)
		
			--special handling for death pits and other instakillers, don't want spyro supercharging on them
			if (dmgtype & DMG_DEATHMASK) return true end
			
			--special handling for tnt barrels
			if inflictor and inflictor.type == MT_TNTBARREL and not p.supercharging
				return true
			end
			
			--do normal checks w/ missiles
			if inflictor and (inflictor.flags & MF_MISSILE)
				return nil
			end
			
			--special handling for eggman's nefarious tv magic
			if inflictor and inflictor.type == MT_EGGMAN_ICON
				return nil
			end
			
			--pain objects are painful
			if inflictor and (inflictor.flags & MF_PAIN) and not p.supercharging
				--special handing for brak eggman's napalm and other fire types
				if inflictor.type == MT_CYBRAKDEMON_NAPALM_FLAMES or (inflictor.flags & MF_FIRE)
				and (p.powers[pw_shield] & SH_PROTECTFIRE)
					return nil
				end
				
				--S_StartSound(mo, sfx_s3k49)
				return nil
			end
			
			if p.supercharging then S_StartSound(target, sfx_flerr) end
			
			return false
		end
	end
end, MT_PLAYER)

--more player charge damage crap cuz i leik spagetty
addHook("PlayerCanDamage", function(p, enemy)
	if (p.charging or p.aircharging)
	--and not p.bannedvars
	and not valueInTable(p.mo.state, bannedStates) 
	and enemy and enemy.valid
	and R_PointToAngle2(p.mo.x, p.mo.y, enemy.x, enemy.y) - p.drawangle <= ANGLE_90
		
		--special handling for red & gold buzzes
		if(enemy.type == MT_GOLDBUZZ or enemy.type == MT_REDBUZZ)
		and p.powers[pw_flashing] == 0
		and p.powers[pw_invulnerability] == 0
		and p.powers[pw_super] == 0
		--and not p.homing
		and not p.supercharging
			if p.powers[pw_shield] == SH_ATTRACT
			and (p.pflags & PF_SHIELDABILITY)
			--and p.homing
				return true
			end
			
			--damage enemy if charged from above
			if p.mo.z > enemy.z
				return true
			end
			
			--otherwise play spiked sound and don't harm enemy
			--spyro will later be harmed
			S_StartSound(p.mo, sfx_spkdth) --all this to play a sound???
			return false
		end
		
		--special handling for egg collosseum eggman
		if (p.charging or p.aircharging)
		and enemy.type == MT_EGGMOBILE4
			p.charging = false
			p.aircharging = false
			p.powers[pw_nocontrol] = TICRATE/2
			p.powers[pw_flashing] = TICRATE*2
			p.mo.angle = R_PointToAngle2(enemy.x, enemy.y, 0, 0)
			P_InstaThrust(p.mo, p.mo.angle+ANGLE_180, 36*p.mo.scale)
			--mo.player.pflags = $ | PF_SPINNING
			P_SetObjectMomZ(p.mo, 6*p.mo.scale)
			p.mo.state = S_PLAY_ROLL
			--P_DamageMobj(enemy, mo, mo, 1)
			return true
		end
		
		--special handling for egg guard's eggshield
		if enemy.type == MT_EGGSHIELD
			enemy.target = mo
			return true
		end
		
		--speical handling for spikes
		if (p.charging or p.aircharging)
		and (enemy.type == MT_SPIKE or enemy.type == MT_WALLSPIKE)
		and p.supercharging
			P_KillMobj(enemy, p.mo)
			return true
		end
		
		--special handling for boss metalsonic
		if (p.charging or p.aircharging)
		and enemy.type == MT_METALSONIC_BATTLE
			return true
		end
		/*
		--special handling for gem containers (chests, vases, baskets, etc.)
		if constantExists("MT_SPYRO_BASKET")
			if enemy.type == MT_SPYRO_BASKET --requires a special fixed version of the basket code, otherwise it does fuck-all but play sounds
				enemy.charged = true --supposed to set spawned gem as 'marked' and not 'airborne' to enable homing
				enemy.charger = mo --target for the marked gem to home in on
				S_StartSound(enemy, sfx_bskbrk)
			end
			return nil
		end
		*/
		--supercharging is guaranteed damage
		if p.supercharging 
			P_DamageMobj(enemy, p.mo, p.mo, 99)
			return true -- +1 atk
		end
		
		--bonking against bonkable playerskins, no harm
		if (enemy.player and valueInTable(enemy.skin, chargeableBonk))
			p.charging = false
			p.aircharging = false
			P_DoPlayerPainNoIframe(p)
			S_StartSound(mo, sfx_s3k49)
			--print("playerbonk")
			return false
		end
		
		--bonking against enemies
		if valueInTable(enemy.type, chargeableBonk)
		or (enemy.player and valueInTable(enemy.skin, chargeableBonk))
		or enemy.health > 1
			if enemy.flags & (MF_ENEMY|MF_BOSS)
			or enemy.type == MT_PLAYER
				p.charging = false
				p.aircharging = false
				local ang = R_PointToAngle2(enemy.x - enemy.momx, enemy.y - enemy.momy, p.mo.x, p.mo.y)
				P_DoPlayerPainNoIframe(p, enemy, enemy, nil)
				
				if not valueInTable(enemy.type, nonchargeableEnemies)
				or valueInTable(enemy.skin, chargeableBonk)
					P_DamageMobj(enemy, p.mo, p.mo, 1)
				else
					S_StartSound(mo, sfx_s3k49)
				end
				
				if p.powers[pw_flashing] < TICRATE/4
					p.powers[pw_flashing] = TICRATE/4
				end
				
				if enemy.type ~= MT_METALSONIC_BATTLE --metalsonic is special
					do return end --code is being dumb, breaking out of the entire script so that spyro is knocked back the correct direction :|
				end
			end
		end
		
		--don't harm non-chargeables
		if valueInTable(enemy.type, nonchargeableEnemies)
			--S_StartSound(mo, sfx_s3k49)
			--print("nonchargeable")
			return false
		end
		
		--don't harm other players in certain gamemodes or same team
		if (G_GametypeHasTeams() and enemy.player
		and p.ctfteam == enemy.player.ctfteam 
		and not cv_friendlyfire.value)
		or gametype & GT_COOP 
			--print("incompat gametype")
			return false
		end
		
		--enemies/monitors/bosses are damaged
		--if enemy.flags & (MF_MONITOR|MF_ENEMY|MF_BOSS)
		--	print("generic")
		--	return true
		--end
		
		--otherwise damage
		return true
	end
end)

--charge through wall stuff (based on Yoshi - SMS Alfredo)
local spyroChargeWall = function(mobj, sectorthing)
	local nerds = false
	local p = mobj.player
	local sectordata = P_PlayerTouchingSectorSpecial(p, 0, 0)
	/*
	for fof in sectorthing.ffloors()
		if (fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
		and (fof.topheight + 10*FRACUNIT) >= mobj.z+mobj.height 
		and (fof.bottomheight - 10*FRACUNIT) <= mobj.z
		and (mobj.player.charging or mobj.player.aircharging))
			EV_CrumbleChain(sectorthing, fof)
			nerds = true
			
			if not mobj.player.supercharging then P_DoPlayerPainNoIframe(mobj.player) end
			
			mobj.player.chargecooldown = 7
		end
	end
	*/
	for fof in sectorthing.ffloors()
		if (fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
		and fof.sector
		and (fof.topheight + 10*FRACUNIT) >= mobj.z+mobj.height 
		and (fof.bottomheight - 10*FRACUNIT) <= mobj.z
		and (mobj.player.charging or mobj.player.aircharging))
			EV_CrumbleChain(sectorthing, fof)
			nerds = true
			
			if not mobj.player.supercharging then P_DoPlayerPainNoIframe(mobj.player) end
			
			mobj.player.chargecooldown = 7
		end
	end
	
	return nerds
end

--line collision hook to charge through bustable walls
addHook("MobjLineCollide", function(mobj, line)
	local killone
	local killtwo
	
	local function safeSlope(rise_y,run_x)
		if run_x
			return FixedDiv(rise_y,run_x)
		else
			return 0 --don't want any divide-by-zero stuff
		end
	end
	--set player linecollide var
	--kudos to kays for pointing me in the right direction
	mobj.linecollide = line
	mobj.linecollide_slope = safeSlope(line.dx, line.dy)
	mobj.linecollide_ang = R_PointToAngle2(0,0,line.dx,line.dy)
	mobj.momang = R_PointToAngle2(0,0,mobj.momx,mobj.momy)
	mobj.linecollide_momangdiff = angfix(mobj.linecollide_ang - mobj.momang)+ANGLE_90
	
	--print((angfix(mobj.linecollide_ang - mobj.momang)+ANGLE_90)/ANG1)
	--print((mobj.linecollide_ang - R_PointToAngle2(0,0,mobj.momx,mobj.momy))/ANG1)
	
	if not (line and line.valid and mobj and mobj.valid) then return end
	
	if mobj.player.charging or mobj.player.aircharging
	--or (mobj.player.pflags & PF_SPINNING)
	or mobj.state == S_PLAY_ROLL
	
		--bust wall
		if line.frontsector and line.frontsector.valid 
			killone = spyroChargeWall(mobj, line.frontsector)
		end
		if line.backsector and line.backsector.valid
			killtwo = spyroChargeWall(mobj, line.backsector)
		end
	end
end, MT_PLAYER)

--for bonking against obstacles
addHook("MobjMoveBlocked", function(mobj)
	if mobj and mobj.player and mobj.skin == "spyro"
		local p = mobj.player
		if p.bonkcounter == nil then p.bonkcounter = 5 end
		--if mobj.player.bonkcounter == 0 then mobj.player.bonkcounter = 5 end
		--mobj.bonkcounter = 5
		
		--get difference between charge angle and momentum angle
		local reactang = R_PointToAngle2(p.mo.x, p.mo.y, p.mo.x + p.rmomx, p.mo.y + p.rmomy)
		local angdiff = p.chargeangle - reactang
		
		--print((p.mo.angle - p.drawangle)/ANG1)
		--print(p.mo.angle/ANG1)
		
		-- B   O   N   K
		if ((p.charging or p.aircharging or p.gliding)
		or (p.powers[pw_shield] == SH_FLAMEAURA and (p.pflags & PF_SHIELDABILITY)))
		and p.bonkcounter <= 0 and cv_bonk.value == 1
		and p.speed < FixedMul(FixedMul(p.chargespeed, cv_spyrospeedmul.value), mobj.scale)/4
		and abs(angdiff) > ANGLE_45
			/*
			if p.powers[pw_shield] == SH_FLAMEAURA 
			and (p.pflags & PF_SHIELDABILITY)
				--P_SpawnMobjFromMobj(mobj, 0, 0, mobj.scale * 2, MT_SPYROFIRESUPER)
				P_SPMAngle(mobj, MT_SPYROFIRESUPER, p.drawangle, 0, MF2_EXPLOSION)
			end
			*/
			
			P_DoPlayerPainNoIframe(mobj.player)
			
			if (p.aircharging or p.gliding) --kill zmom if spyro is aircharging/gliding
			and not p.charging
			and not P_IsObjectOnGround(mobj)
				P_SetObjectMomZ(mobj, -2*mobj.scale)
			end
			
			p.gliding = false
			p.glidecooldown = $ + (TICRATE*3)/4 -- ~0.75sec
			p.shieldcooldown = $ + (TICRATE*3)/4 -- ~0.75sec
			if p.powers[pw_shield] == SH_WHIRLWIND --"activate" these shields so that shieldcooldown does it job
			or (p.powers[pw_shield] & SH_FORCE)
				p.pflags = $ | PF_SHIELDABILITY
			end
			
			--p.glidecooldown = TICRATE*1
			p.charging = false
			p.aircharging = false
			S_StartSound(mobj, sfx_sbonk)
			p.bonked = true
			p.chargecooldown = 7
			
		elseif (p.charging or p.aircharging or p.gliding)
		or (p.powers[pw_shield] == SH_FLAMEAURA and (p.pflags & PF_SHIELDABILITY))
			p.bonkcounter = $ -1
		else 
			if p.supercharging
				p.bonkcounter = TICRATE/3
			else
				p.bonkcounter = TICRATE/7
			end
		end
		
		--if spyro doesn't b o n k then re-direct his charge angle
		if p.charging or p.aircharging
			p.chargeangle = reactang
		end
		
		--print(p.bonkcounter)
	end
end, MT_PLAYER)

--kill mobs with elecbreath
addHook("MobjMoveCollide", function(fire, enemy)
	if valueInTable(enemy.type, nonzappableEnemies)
	or (enemy.player and valueInTable(enemy.skin, nonzappableEnemies))
	or (enemy.player and (enemy.player.powers[pw_shield] & SH_PROTECTELECTRIC))
	and not fire.target == enemy
		--don't proc if we vertically miss
		if(enemy.z > fire.z+fire.height) or (fire.z > enemy.z+enemy.height)
			return nil
		end
		S_StartSound(fire, sfx_flerr)
		P_KillMobj(fire, nil, nil)
		return false
	end
end, MT_SPYROELEC1)

--kill mobs w/ charged-up elecbolt
addHook("MobjMoveCollide", function(fire, enemy)
	if valueInTable(enemy.type, nonzappableEnemies)
	or (enemy.player and valueInTable(enemy.skin, nonzappableEnemies))
	or (enemy.player and (enemy.player.powers[pw_shield] & SH_PROTECTELECTRIC))
	and not fire.target == enemy
		--don't proc if we vertically miss
		if(enemy.z > fire.z+fire.height) or (fire.z > enemy.z+enemy.height)
			return nil
		end
		S_StartSound(fire, sfx_flerr)
		P_KillMobj(fire, nil, nil)
		return false
	else --wow you get to do TWO hitpoints of damage?
		--don't proc if we vertically miss
		if(enemy.z > fire.z+fire.height) or (fire.z > enemy.z+enemy.height)
			return nil
		end
		P_DamageMobj(enemy, fire, fire.target, 2, DMG_ELECTRIC)
		P_KillMobj(fire, nil, nil)
	end
end, MT_SPYROELEC2)

--kill mobs w/ fire breath
addHook("MobjMoveCollide", function(fire, enemy)
	
	--don't proc if we vertically miss
	if(enemy.z > fire.z+fire.height) or (fire.z > enemy.z+enemy.height)
	or enemy.flags2 & MF2_FRET
		return nil
	end
	
	--special handling for boss metalsonic
	if enemy.type == MT_METALSONIC_BATTLE
	--and (enemy.flags & MF_SHOOTABLE)
		--don't proc if we vertically miss
		if(enemy.z > fire.z+fire.height) or (fire.z > enemy.z+enemy.height)
		or enemy.flags2 & MF2_FRET
			return nil
		end
		--enemy.flags = $ | MF_SHOOTABLE
		--P_DamageMobj(enemy, fire, fire.target, 1, DMG_FIRE)
		fire.flags = $ | MF_MISSILE
	end
	
	--special handling for dirk's icespray (fire beats ice)
	--for when that ice spray becomes tangible one day..
	if constantExists("MT_ICESPRAY")
		if enemy.type == (MT_ICESPRAY|MT_THROWNICESPRAY)
			P_KillMobj(enemy, nil, nil)
		end
	end
	
	--special handling for players
	if enemy.type == MT_PLAYER and enemy.player and enemy.player.valid
	and fire.target ~= enemy
		--don't proc if we vertically miss
		if(enemy.z > fire.z+fire.height) or (fire.z > enemy.z+enemy.height)
		 return nil
		end
		
		fire.flags = $ | MF_MISSILE
		
		--P_DamageMobj(enemy, fire, fire.target, 1, DMG_FIRE)
		--P_KillMobj(fire, nil, nil)
	end
	
	--play ping sound and kill flame when it touches a non-flammable enemy
	if valueInTable(enemy.type, nonflammableEnemies)
	or (enemy.player and valueInTable(enemy.skin, nonflammableEnemies))
		--don't proc if we vertically miss
		if(enemy.z > fire.z+fire.height) or (fire.z > enemy.z+enemy.height)
		or enemy.flags2 & MF2_FRET
			return false
		end
		
		S_StartSound(fire, sfx_flerr)
		P_KillMobj(fire, nil, nil)
		return false
	elseif fire.target ~= enemy --don't flame myself
	or (enemy.flags & (MF_ENEMY|MF_BOSS))
	or (enemy.flags & (MF_SCENERY & MF_SOLID))
	--and not(enemy.flags & (MF_SCENERY & ~MF_SOLID)) --don't interact w/ non-solid scenery
		--don't proc if we vertically miss
		if(enemy.z > fire.z+fire.height) or (fire.z > enemy.z+enemy.height)
		or enemy.flags2 & MF2_FRET
			return false
		end
		fire.flags = $ | MF_MISSILE
		--P_KillMobj(fire, nil, nil)
	end
end, MT_SPYROFIRE)

--make ABSOLUTELY sure that we actually hit the other player, b/c Dirk always seems to find a way to break Spyro's flame breath
addHook("ShouldDamage", function (enemy, fire, src, dmg, dmgtype)
	--print(gametype & GT_COOP)
	if (fire and fire.valid)
	and (enemy and enemy.valid)
	and enemy.type == MT_PLAYER
	and fire.type == MT_SPYROFIRE
		if gametype == GT_COOP
			return false
		end
		
		if(G_GametypeHasTeams() and fire.target.player.ctfteam == enemy.player.ctfteam and not cv_friendlyfire.value)
			return false
		end
		
		if CBW_Battle
			if CBW_Battle.MyTeam(fire.target.player, enemy.player)
				return false
			end
		end
		
		if enemy.player.powers[pw_flashing]
		or enemy.player.powers[pw_super]
		or enemy.player.powers[pw_invulnerability]
		or (enemy.player.powers[pw_shield] & SH_PROTECTFIRE)
		or (enemy.player.pflags & PF_GODMODE)
			return false
		end
		
		return true
	end
	/*
	if (fire and fire.valid)
	and fire.type == MT_SPYROFIRE
	and enemy.type == MT_PLAYER
	and enemy.type == MT_METALSONIC_BATTLE
	and not(gametype == GT_COOP)
	and not (G_GametypeHasTeams() and fire.target.player.ctfteam == enemy.player.ctfteam and not cv_friendlyfire.value)
	and not (enemy == fire.target)
	and not (enemy.player.powers[pw_shield] & SH_PROTECTFIRE)
	and not enemy.player.powers[pw_flashing]
	and not enemy.player.powers[pw_super]
	and not enemy.player.powers[pw_invulnerability]
		--P_DamageMobj(enemy, fire, fire, 1, DMG_FIRE)
		return true
	end
	*/
	--special handling for battlemod objects
	--if valueInTable(enemy.type, nonflammableEnemies)
	--	return false
	--end
end, MT_PLAYER)

--kill fire if stopped
addHook("MobjMoveBlocked", function(fire)
	if CBW_Battle then return end
	P_SetObjectMomZ(fire, 2*FRACUNIT, false)
	P_KillMobj(fire, nil, nil)
end, MT_SPYROFIRE)

--lil puff o' smoke goes up when flame goes out by abusing momentum
addHook("MobjDeath", function(fire, inflictor, src, dmgtype)
	P_InstaThrust(fire, fire.angle, 0)
	P_SetObjectMomZ(fire, 2*FRACUNIT, false)
end, MT_SPYROFIRE)


--superflame explod fire thinker
addHook("MobjThinker", function(fire)
	--Flame Touches Ground and Gets Grounded (GoAnimate)
	if P_IsObjectOnGround(fire) and not fire.gnd
		fire.gnd = true --you're grounded
		P_SetObjectMomZ(fire, 1*FRACUNIT, false) --need zmom for later
	end
	
	--give missile flag when grounded and "starting to fall" otherwise the flame will die when it touches ground
	--also gives scenery flag for some (hopefully) extra performance
	if fire.momz == 0
	and fire.gnd
	and not (fire.flags & MF_SCENERY)
		fire.flags = $ | MF_SCENERY
		fire.flags = $ | MF_MISSILE
	end
	
	--if fire.eflags & (MFE_TOUCHWATER)
	--	print("touchwater")
	--	P_RemoveMobj(fire)
	--end
end, MT_SPYROFIRESUPER_FLAMEREST)


--POSTTHINKFRAME CRAP
addHook("PostThinkFrame", function()
	for p in players.iterate
		if p.mo and p.mo.skin == "spyro"
		
			--purge linecollide var
			p.mo.linecollide = nil
			p.mo.linecollide_slope = nil
			p.mo.linecollide_ang = nil
			
			--fixes runspeed that battlemod was overriding
			--spyro will properly charge underwater now
			if CBW_Battle
				if p.charging or p.aircharging
					if (p.mo.eflags & MFE_UNDERWATER)
						p.runspeed = 0
					end
				else
					p.runspeed = p.normalspeed + (25*p.mo.scale)
				end
			end
		end
	end
end) 
