--OTHER ADDON INTEGRATION--

local ggcapsule = false
local mysticrealm = false
local amtcrawla = false
local wtfsonic = false
local sonic1983 = false
local glabber = false
local sunsetchaos = false
local kirby = false

--constant global that lets others know that spyro is present
rawset(_G, "SPYRO_N1024", true)

addHook("ThinkFrame", function()
	--only run at a certain time when ingame
	--gotta save dem cycles ya'know?
	if leveltime and leveltime % TICRATE ~= 0 --only run once a second
		return
	end
	
	--kirby integration
	if not kirby and not(kirbyabilitytable) 
		kirby = true
		rawset(_G, "kirbyabilitytable", {}) 
		kirbyabilitytable["spyro"] = 1 --fireball (more like comet dash amirite?)
	end
	
	/*
	--gamegear capsule
	if not ggcapsule
	and constantExists("MT_GGCAPSULE")
		ggcapsule = true
		
		--chargeables
		table.insert(chargeableEnemies, MT_GGCAPSULE)
		
		print("\137SPYRO: Game Gear Capsule added to chargeable/flammable enemy table")
	end
	*/
	/*
	--mystic realm
	if not mysticrealm
	and constantExists("MT_GOGGLESCRAWLA_SLOW")
	and constantExists("MT_GOGGLESCRAWLA_FAST")
		mysticrealm = true
		
		--chargeables
		table.insert(chargeableEnemies, MT_GOGGLESCRAWLA_SLOW)
		table.insert(chargeableEnemies, MT_GOGGLESCRAWLA_FAST)
		table.insert(chargeableEnemies, MT_COCONUTS)
		
		print("\137SPYRO: Mystic Realm chargeable/flammable enemy table set")
	end
	*/
	/*
	--wtfsonic
	if not wtfsonic
	and constantExists("MT_WTFSONIC")
		wtfsonic = true
		
		--chargeables
		table.insert(chargeableEnemies, MT_WTFSONIC)
		
		print("\137SPYRO: WTFSonic chargeable/flammable enemy table set")
	end
	*/
	/*
	--amtcrawla
	if not amtcrawla
	and constantExists("MT_AMTCRAWLA")
		amtcrawla = true
		
		--table.insert(flammableEnemies, MT_AMTCRAWLA)
		--table.insert(chargeableEnemies, MT_AMTCRAWLA)
		
		print("\137SPYRO: MT_AMTCRAWLA added to chargeable/flammable enemy table")
	end
	*/
	--1983sonic level pack
	if not sonic1983
	and constantExists("MT_CONE_DRONE")
	and constantExists("MT_CONE_SPIKEBALL")
	and constantExists("MT_SPINY")
	and constantExists("MT_MOTOBUG")
		sonic1983 = true
		
		--flammables
		table.insert(flammableEnemies, MT_CONE_DRONE)
		table.insert(flammableEnemies, MT_MOTOBUG)
		table.insert(flammableEnemies, MT_FLASHER)
		table.insert(flammableEnemies, MT_COCONUTS)
		
		
		--nonflammables
		table.insert(nonflammableEnemies, MT_SPINY)
		table.insert(nonflammableEnemies, MT_CRABMEAT)
		
		--nonzappables
		table.insert(nonzappableEnemies, MT_FLASHER)
		
		--chargeables
		table.insert(chargeableEnemies, MT_CONE_DRONE)
		table.insert(chargeableEnemies, MT_SPINY)
		table.insert(chargeableEnemies, MT_MOTOBUG)
		table.insert(chargeableEnemies, MT_FLASHER)
		table.insert(chargeableEnemies, MT_COCONUTS)
		table.insert(chargeableEnemies, MT_CRABMEAT)
		
		print("\137SPYRO: Sonic1983 Level Pack things added to chargeable/flammable enemy table")
	end
	
	--dimension glabber
	if not glabber
	and constantExists("MT_NEODRILLA")
	and constantExists("MT_TGF_MINUS")
		glabber = true
	
		--flammables
		table.insert(flammableEnemies, MT_NEODRILLA)
		--table.insert(flammableEnemies, MT_Bluecrawlaclassic)
		table.insert(flammableEnemies, MT_BLUECRAWLACLASSIC)
		table.insert(flammableEnemies, MT_REDCRAWLA)
		table.insert(flammableEnemies, MT_TGF_MINUS)
		table.insert(flammableEnemies, MT_USER_MINUS)
		table.insert(flammableEnemies, MT_GHOST)
		table.insert(flammableEnemies, MT_SPEC)
		table.insert(flammableEnemies, MT_DRILLA)
		table.insert(flammableEnemies, MT_EGGHEAD)
		table.insert(flammableEnemies, MT_MOTOBUG)
		table.insert(flammableEnemies, MT_FLASHER)
		table.insert(flammableEnemies, MT_SRB1_BAT2)
		
		--chargeables
		table.insert(chargeableEnemies, MT_NEODRILLA)
		table.insert(chargeableEnemies, MT_BLUECRAWLACLASSIC)
		table.insert(chargeableEnemies, MT_REDCRAWLA)
		table.insert(chargeableEnemies, MT_DRILLA)
		table.insert(chargeableEnemies, MT_EGGHEAD)
		table.insert(chargeableEnemies, MT_MOTOBUG)
		table.insert(chargeableEnemies, MT_SRB1_BAT2)
		
		--non-zappables
		table.insert(nonzappableEnemies, MT_FLASHER)
	
		--disable snowflakecode
		for p in players.iterate
			COM_BufInsertText(p, "spyrosnowflakecode 0")
			--cv_spyrosnowflakecode.value = 0
		end
			
		print("\137SPYRO: Dimension Glaber chargeable/flammable enemy table set")
		print("\137SPYRO: Snowflake code disabled")
	end
	
	--sunset over chaos
	if not sunsetchaos
	and constantExists("MT_CIRNO")
	and constantExists("MT_KEROBOSS")
		sunsetchaos = true
		
		--bonkables
		table.insert(chargeableBonk, MT_KEROBOSS)
		table.insert(chargeableBonk, MT_EGGRYUHEAD)
		table.insert(chargeableBonk, MT_EGGRYUTAIL)
		table.insert(nonchargeableEnemies, MT_KEROBOSS)
		table.insert(nonchargeableEnemies, MT_EGGRYUHEAD)
		table.insert(nonchargeableEnemies, MT_EGGRYUTAIL)
		
		--chargeables
		table.insert(chargeableEnemies, MT_CIRNO)
		table.insert(chargeableEnemies, MT_RATBOSS)
		table.insert(chargeableEnemies, MT_RATMOOK)
		table.insert(chargeableEnemies, MT_ULTEGG)
		table.insert(chargeableEnemies, MT_FINALBOSS)
		
		--nonflammables
		table.insert(nonflammableEnemies, MT_RATBOSS)
		table.insert(nonflammableEnemies, MT_RATMOOK)
		
		print("\137SPYRO: Sunset Over Chaos chargeable/flammable enemy table set")
	end
end)

--HATS--
--check for hats
local spyrohatinit = false
addHook("ThinkFrame", function()
	if spyrohatinit then return end
	if not hatwad then return end
	
	spyrohatinit = true
	freeslot(S_HATFOLLOWSPY1, S_HATFOLLOWSPY2)
	
	states[S_HATFOLLOWSPY1] = {SPR_NULL, A, 1, A_CapeChase, 0, 48, S_HATFOLLOWSPY1}
	states[S_HATFOLLOWSPY2] = {SPR_NULL, A, 1, A_CapeChase, 0, 33, S_HATFOLLOWSPY2}
end)

--hatwad
addHook("PlayerThink", function(p)
	if not hatwad then return end
	
	--local headoffset_x = P_ReturnThrustX(p.mo, p.drawangle, 12*FRACUNIT)
	--local headoffset_y = P_ReturnThrustX(p.mo, p.drawangle, 12*FRACUNIT)
	--local headoffset_z = 0
	
	--no hats for spyro, they look silly on him
	if p.mo and p.mo.skin == "spyro"
		if p.mo.hat
		and p.mo.hattype ~= "NOHAT"
			COM_BufInsertText(p, "hat 0")
			CONS_Printf(p, "\133Your hat fell off... It doesn't fit on your head!\128")
		end
	end
end)

--MENU LIBARAY--
--menulib safety
addHook("PlayerThink", function(p)
	if not menulib then return end
	
	--menu interferes with spyro's hover move, so we close it if he's in the air
	if p.mo and p.mo.skin == "spyro"
		if p.menu
		and not P_IsObjectOnGround(p.mo)
			menulib.close(p, force)
		end
	end
end)